import "lib/ygs_bulletml.dll" //BulletML
import "lib/dlltest.dll"      //蔻
import "lib/bass4ygs.dll"     //bass sound system
include "lib/bass4ygs.h"

long BMAX = 512;
long tf[512], tx[512], ty[512], tt[512], td[512];
long MISSOVER = 500;
long jx,jy,csize,bsize,ctimer;
long bgm,wav1,wav2,wav3,wav4,ch4;
long snd1, snd2;
long scrmode;

long score, combo, mcombo;
long bombs, isbomb, bombtime;
long miss, isover, overtime;
long maxscore, maxcombo;

long BMLMAX = 12;
long bmlsp[12];

void bmlload() {
	long i;
	for(i=0; i<BMLMAX; i++) {
		bmlsp[i] = 1;
	}
	bml_loadBML(0, "xml/[DragonBlaze]_nebyurosu_2.xml");
	bml_loadBML(1, "xml/[ESP_RADE]_round_123_boss_satoru_5way.xml");
	bml_loadBML(2, "xml/[MDA]_acc_n_dec.xml");
	bml_loadBML(3, "xml/[Noiz2sa]_5_players.xml");
	bml_loadBML(4, "xml/[Progear]_round_1_boss_grow_bullets.xml"); bmlsp[4] = 3;
	bml_loadBML(5, "xml/[ESP_RADE]_round_5_boss_gara_2.xml");
	bml_loadBML(6, "xml/[Dodonpachi]_hibachi.xml");
	bml_loadBML(7, "xml/[Daiouzyou]_hibachi_2.xml"); bmlsp[7] = 2;
	bml_loadBML(8, "xml/[ESP_RADE]_round_5_boss_gara_5.xml");
	bml_loadBML(9, "xml/[Progear]_round_2_boss_struggling.xml"); bmlsp[9] = 2;
	bml_loadBML(10, "xml/pan2.xml"); bmlsp[10] = 1;
	bml_loadBML(11, "xml/[Ketui_LT]_3boss_kunekune.xml"); bmlsp[11] = 2;
	bml_loadBML(63, "xml/yuudou.xml");
}

void quit() {
	bass_streamfree(bgm);
	bass_samplefree(wav1);
	bass_samplefree(wav2);
	bass_samplefree(wav3);
	bass_free();
	/*	
	ReleaseWaveAll();
	*/
	bml_quit();
//	delete(bmlsp);
	Quit();
}

void init() {
	long i;

	maxscore = gameflag[0];
	maxcombo = gameflag[1];
	scrmode  = gameflag[2];

	SetDisplayMode(0,2);	//mode1: window mode / mode2: full screen 256 colors
	ChangeDisplayMode(scrmode+1);

	LoadBitmap("image/redline.bmp",0,0);
	LoadBitmap("image/pen01.bmp",  1,0); SetColorKeyPos(1,0,0);
	LoadBitmap("image/dokuro.bmp", 2,0); SetColorKeyPos(2,0,0);
	LoadBitmap("image/pen03.bmp",  3,0); SetColorKeyPos(3,0,0);
	LoadBitmap("image/blueline.bmp",4,0);
	LoadBitmap("image/pen.bmp",5,0);

	LoadBitmap("image/cursor1.bmp",14,0); SetColorKeyPos(14,0,0);
	LoadBitmap("image/cursor2.bmp",15,0); SetColorKeyPos(15,0,0);
	LoadBitmap("image/toumei.bmp" ,16,0);  SetColorKeyPos(16,0,0);

//	LoadBitmap("image/okutama.jpg",32,1);
	LoadBitmap("image/netsu.jpg",  33,0); //RealizePalette(33);
	LoadBitmap("image/chidori.jpg",34,0); //RealizePalette(34);
	LoadBitmap("image/ecolium.jpg",35,0); //RealizePalette(35);
	LoadBitmap("image/titan.jpg",  36,0); //RealizePalette(36);
	
	LoadBitmap("image/title.bmp", 64,0); //RealizePalette(64);
	LoadBitmap("image/buta.bmp" , 65,0);  SetColorKeyPos(65,0,0);
	LoadBitmap("image/buta32.bmp",66,0);  SetColorKeyPos(66,0,0);
	LoadBitmap("image/bomb.bmp" , 67,0);  SetColorKeyPos(67,0,0);
	
	bml_init(BMAX, 1);     //ygsbml(eMAX=BMAX, e{x2)
	bml_setRot(90);              //Wn90]BV[ɂȂ邼B
	bmlload();

	bass_init(-1,44100,0);
	bass_start();
	wav1 = bass_sampleload("sound/push33.wav", 1, BASS_SAMPLE_OVER_POS);
	wav2 = bass_sampleload("sound/hit56_a.wav", 2, BASS_SAMPLE_OVER_POS);
	wav3 = bass_sampleload("sound/fm013.wav", 3, BASS_SAMPLE_OVER_POS);
	wav4 = bass_sampleload("sound/siren.wav", 4, BASS_SAMPLE_LOOP);
	bass_setstreamvolume(60);
	bass_setsamplevolume(48);
	/*
	LoadWave("sound/cranky - Luvin' You ''C&C mix''.mp3", 0);
	SetLoopModeWave(0,1);
	LoadWave("sound/push33.wav",  1);
	LoadWave("sound/hit56_a.wav", 2);
	SetVolumeWaveAll(-512);
	*/
//	SetVolumeWave(0, 0);

	
//	MouseLayerOff();
	SetFPS(60);
}

void title() {
	long mx,my,mb;

	TextColor(10, 0,0,0); TextSize(10, 12); TextLayerOn(10, 400, 453); //ō_
	TextColor(11, 0,0,0); TextSize(11, 12); TextLayerOn(11, 400, 465); //MAXR{
	TextBackColorDisable(10); TextBackColorDisable(11);
	MouseLayerOn(5,0,0);
	loop {
		KeyInput();
		GetMouseInfo(&mx, &my, &mb);
		if(IsPushEscKey()) quit();
		if(IsPushKey(0x3E)) { // F4L[ꂽȂEEE
			scrmode = (scrmode + 1) % 2;
			ChangeDisplayMode(scrmode+1);
			gameflag[2] = scrmode;
			SaveGameFlag("config.fig");
		}
		ClearSecondary();
		BltFast(64, 97, 4);
		sprintf(string[0], "ĸ: %09d0", maxscore);
		TextOut(10, string[0]);
		sprintf(string[1], "ϯ: %010d", maxcombo);
		TextOut(11, string[1]);
		halt;
		if (mb&2) break;
	}
	TextLayerOff(10);
	TextLayerOff(11);
}

void main() {
	init();
	loop {
		title();
		maingame();
	}
}

void maingame() {
	long mx,my,mb;
	long click;
	long term;
	long bmlno, no, tama;
	long i;
	long bg;
	long combox;
	long loops;
	
	MouseLayerOn(16,0,0);
//	TextLayerOn(0,   0, 0); //mx, my\
	TextLayerOn(1, 240, 0); TextColor(1, 255,160, 0); TextSize(1, 24); //miss\
	TextLayerOn(2, 575, 0); //e(pen)\
	TextLayerOn(3,   0, 0); TextSize(3, 24); //XRA\
	TextColor(4, 255,255,0); TextSize(4, 64); //R{\
	combox = 432; TextColor(5, 255,0,0); TextSize(5, 24); TextOut(5, "COMBO"); //uCOMBOv\
	TextColor(6, 255,0,0); TextSize(6, 96); TextOut(6, "THE END"); //GAME OVER
	TextColor(7, 255,255,0); TextSize(7, 96); TextOut(7, "HIGH SCORE!"); //HIGH SCORE!
	FPSLayerOn(500,448);

	click = 0;
	term = 0;
	loops = 0;

	csize = 84; ctimer = 0;
	bsize = 65536 * csize / 84;
	bg = 33;
	bmlno = 0;

	score = 0;
	combo = 0; mcombo = 0;
	bombs    = 3; isbomb   = 0; bombtime = 0;
	miss     = 0; isover   = 0; overtime = 0;
	
	bml_setSeed(573);            //_V[hw
	bml_deleteAll(&tf);
	for(i=0; i<BMAX; i++) {
		tf[i]=0;
	}
	
	bgm = bass_streamcreate("sound/cranky - Luvin' You.mp3", 0);
	bass_streamplay(bgm,BASS_SAMPLE_LOOP);
	/*
	PlayWave(0);
	*/
	loop {
		KeyInput();
		if(IsPressEscKey())   quit();
		if(IsPressSpaceKey()) break;
		snd1 = 0; snd2 = 0;

		if(isover) goto bml;
		/* }EXJ[\ړ */
		GetMouseInfo(&mx, &my, &mb);
		if (mb&2) {
			if (click==0) {
				click = 1;
//				MouseLayerOn(15,0,0);
			}
		} else {
			if (click==1) {
				click = 0;
				combo = 0;
//				MouseLayerOn(14,0,0);
				TextLayerOff(4);
				TextLayerOff(5);
			}
			if ((mb&1)&&(isbomb==0)&&(bombs>0)) {
				isbomb = 1; bombtime = 180; bombs--;
				csize = 84; ctimer = 0;
			}
		}
		
		if(mx <  64) mx = 64;
		else if(mx > 320) mx = 320;
		if(my > 452) my = 452;
		else if(my < 0) my = 0;

		if (isbomb) {
			for(i=0; i<BMAX; i++) {
				if ((tf[i] > 0)&(tt[i] > 0)&&(tt[i] < 63)) {
					if ((tx[i] >= (mx-128))&&(tx[i] < (mx+212))) {
						if ((ty[i] >= (my-128))&&(ty[i] < (my+212))) {
							bml_change2Action(i, &tf, 63, 50, 63, 1);
						}
					}
				}
			}
			bombtime--;
			if (bombtime<=0) {
				for(i=0; i<BMAX; i++) {
					if ((tf[i] > 0)&(tt[i]==63)) bml_change2Simple(i, &tf, -512, 0, 1);
				}
				bsize = 65536;
				isbomb = 0;
			}
		}
		
		/* 蔻 */
		if ((click)||(isbomb)) {
			for(i=0; i<BMAX; i++) {
				if ((tf[i] > 0)&(tt[i] > 0)) {
					if ((tx[i] >= mx)&&(tx[i] < (mx+csize))) {
						if ((ty[i] >= my)&&(ty[i] < (my+csize))) {
							bml_change2Simple(i,&tf, 1680,0,-2); //yɃLbv͂߂ČԂ
//							tt[i] = -2;
							snd1 = 1;
							if (!isbomb) {
								combo++;
								if(combo > mcombo) mcombo = combo;
								if (combo == 1) {
									TextLayerOn(4, 450, 0);
									TextLayerOn(5, 482, 32);
								}
								if (combo == 10) TextMove(5, 514, 32);
								else if (combo == 100) TextMove(5, 546, 32);
								else if (combo == 1000) TextMove(5, 578, 32);
								score = score + combo;
							} else {
								score++;
							}
						}
					}
				}
			}
			if (!isbomb) {
				ctimer++;
				if(ctimer>=8) {
					ctimer = 0;
					if(csize >= 32) {
						csize = csize -2; 
						bsize = 65536 * csize / 84;
					}
				}
			}
		} else {
//			if ((mb&1)&&(csize < 84)) {
				if (csize <= 76) {
					ctimer--;
					if (ctimer <= 0) {
						csize = csize + 8;
						bsize = 65536 * csize / 84;
						ctimer = 7;
					}
				}
//			}
		}
bml:			
		/* BulletML쓮 */
		if (!(term % 600)) {
			if ((loops>0)&&(bmlno==0)) {
				bg++; if (bg > 36) { bg = 33; }
				if (bombs<4) {
					bombs++;
					bass_sampleplay(wav3);
				}
			}
			if(bmlno==3) {
				no = bml_setBullet2(&tf, bmlno, 50, 460,240, 0, 3); //gCAO
			} else {
				no = bml_setBullet2(&tf, bmlno, 50, 560,240, 0, bmlsp[bmlno]);
			}
			bmlno++;
			if (loops == 0) {
				if (bmlno == 11) { bmlno++; }
			}
			else {
				if (bmlno == 4) { bmlno++; }
			}
				if (bmlno >= BMLMAX) { loops++; bmlno = 0; }
		}
		tama = bml_run(mx+8,my+8, &tf,&tx,&ty,&tt,&td); //BulletMLrun(eEړ)
		
		
		/* ` */
//		sprintf(string[0],"mx:%d my:%d", mx, my);
//		TextOut(0, string[0]);
		
		ClearSecondary();
		/*
		BltFastRect(0, 0,0, (term%640),0, (640-(term%640)), 480);
		BltFast(0,(640-(term%640)),0);
		*/
		BltFast(bg, 0, 0);
		BltFast( 0, 63,0); //red line
		BltFast( 4, 320+csize,0); //blue line
		draw();
		if(!isover) {
			if (isbomb) {
				if ((bombtime>50)||((bombtime>>1)&1)) Blt(65, mx, my);
			} else {
				BltR(14+click, mx, my, bsize, bsize);
			}
		}
		for(i=0; i<bombs; i++) {
			Blt(67, 500+i*34, 420);
		}
		
		if ((!isover)&&(miss >= (MISSOVER-100))) {
			if ((term%40)==0) TextColor(1, 255,160, 0);
			else if ((term%40)==20) TextColor(1, 255, 0, 0);
		}

		sprintf(string[1],"sǔ:%d/%d", miss, MISSOVER);
		TextOut(1, string[1]);
		sprintf(string[2],"pens:%d", tama);
		TextOut(2, string[2]);
		sprintf(string[3],"SCORE: %09d0", score);
		TextOut(3, string[3]);
		sprintf(string[4],"%d", combo);
		TextOut(4, string[4]);

		if(snd1) bass_sampleplay(wav1);
		if(snd2) bass_sampleplay(wav2);
		/*
		if(snd1) PlayWave(1);
		if(snd2) PlayWave(2);
		*/
		
		halt;
		term++;
		if(isover) {
			overtime--;
			if(overtime <= 0) break;
		}
	}
	
	/* I */

	if(isover) {
		if ((score  > maxscore)||(mcombo > maxcombo)) {
			if (score  > maxscore) maxscore = score;
			if (mcombo > maxcombo) maxcombo = mcombo;
			gameflag[0] = maxscore;	//score
			gameflag[1] = maxcombo;	//combo
			SaveGameFlag("config.fig");
		}
	}
	bass_streamfree(bgm);
//	StopWave(0);
//	TextLayerOff(0);
	TextLayerOff(1);
	TextLayerOff(2);
	TextLayerOff(3);
	TextLayerOff(4);
	TextLayerOff(5);
	TextLayerOff(6);
	TextLayerOff(7);
	FPSLayerOff();
	return;
}

void draw() {
	long i, bgy;
	long d;

	for(i=0; i<BMAX; i++) {
		if(tf[i]>0) {
			if ((tx[i]<0)|(tx[i]>640)|(ty[i]<0)|(ty[i]>480)) {
				tf[i]=0;
				continue;
			} else if ((tx[i]<64)&(tt[i]>=0)) {
				snd2 = 1;
				miss++;
				if(miss == MISSOVER) {
					isover = 1;
					TextLayerOn(6, 160, 200);
					if (score  > maxscore) TextLayerOn(7, 80, 320);
					bass_channelstop(bgm);
					bass_channelstop(ch4);
					overtime = 180;
				} else if (miss == (MISSOVER-100)) {
					ch4 = bass_sampleplay(wav4);
				}
				bml_change2Simple(i,&tf, -512,0,-1);
				tt[i] = -1;
			}
			d = td[i] + 90;
			if(d >= 360) d = d - 360;
//			BltRect(1,tx[i]-4,ty[i]-4, 8*tt[i],16+8*((d+23)/45), 8,8);
			if(tt[i]==-1) {
				Blt(2, tx[i]-24,ty[i]-30);
			} else if (tt[i]==-2) {
				Blt(3, tx[i]-5,ty[i]-8);
			} else {
				Blt(1, tx[i]-5,ty[i]-8);
			}
		}
	}
}
